; FU_stroked_text.scm
; version 1.0 [gimphelp.org]
; last modified/tested by Paul Sherman
; 07/24/2010 on GIMP-2.6.10
;
; 10/01/2008
; Modified to remove deprecated procedures as listed:
;     gimp-text-fontname  ==>  gimp-text-fontname-fontname
;
; Updated to Gimp2.4 (11-2007) http://gimpscripts.com
;
; Updated again to not throw error (needed to define theImage and theDraw)
; 11/30/2007 by Paul Sherman
;
; ------------------------------------------------------------------
; Original information ---------------------------------------------
;
; Unknown
;
; End original information ------------------------------------------
;--------------------------------------------------------------------

(define (text-layer))
(define (textheight))
(define (textheight2))
(define (textwidth))
(define (textwidth2))
(define (stroke-layer))
(define (stoked-text inimage indraw text font font-size stroke text-colour stroke-colour)

(define theImage inimage)
(define theDraw indraw)

(gimp-image-undo-group-start theImage)
(gimp-context-set-foreground text-colour)
(set! text-layer (gimp-text-fontname theImage -1 0 0 text 0 TRUE font-size PIXELS
					     font))
(set! textheight (car (gimp-drawable-height (car text-layer))))
(set! textwidth (car (gimp-drawable-width (car text-layer))))
(gimp-layer-resize (car text-layer) (+ textwidth (* 2 stroke)) (+ textheight (* 2 stroke))
				  stroke stroke)
(gimp-layer-translate (car text-layer) stroke stroke)
(gimp-selection-layer-alpha (car text-layer))
(gimp-selection-grow theImage stroke)
(gimp-context-set-foreground stroke-colour)
(set! textheight2 (car (gimp-drawable-height (car text-layer))))
(set! textwidth2 (car (gimp-drawable-width (car text-layer))))

(set! stroke-layer (gimp-layer-new theImage textwidth2 textheight2 1 "inset" 100 0) )
(gimp-drawable-fill (car stroke-layer) 3)
(gimp-image-add-layer theImage (car stroke-layer) -1)
(gimp-edit-bucket-fill (car stroke-layer) 0 NORMAL 100 0 0 0 0 )
(gimp-image-lower-layer theImage (car stroke-layer))
(gimp-selection-none theImage)
(gimp-image-merge-down theImage (car text-layer) 0 )

(gimp-image-undo-group-end theImage)
(gimp-displays-flush)


)
(script-fu-register "stoked-text"
	"<Image>/Script-Fu/Stoked text"
	"Creates outlined (stroked) text on image."
	"Karl Ward"
	"Karl Ward"
	"Feb 2006"
	"RGB* GRAY*"
	SF-IMAGE      	"SF-IMAGE" 0
	SF-DRAWABLE   	"SF-DRAWABLE" 0
	SF-STRING     	"Text" "Stroked"
	SF-FONT	      	"Font" "Arial"
	SF-ADJUSTMENT	"Font-size" '(100 1 300 1 10 0 1)
	SF-ADJUSTMENT   "Stroke"    '(3 1 20 1 1 1 0)
	SF-COLOR	"Text colour" '(100 255 255)
	SF-COLOR	"Stroke colour" '(0 0 0)
)
				
